Index: trunk/examples/advanced/hadrontherapy/GNUmakefile
===================================================================
--- trunk/examples/advanced/hadrontherapy/GNUmakefile	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/GNUmakefile	(revision 1230)
@@ -1,3 +1,3 @@
-# $Id: GNUmakefile,v 1.5 2004/11/30 09:06:18 guatelli Exp $
+# $Id: GNUmakefile,v 1.12 2009/08/13 20:48:04 kaitanie Exp $
 # --------------------------------------------------------------
 # GNUmakefile for examples module.  Gabriele Cosmo, 06/04/98.
@@ -15,9 +15,19 @@
 all: lib bin
 
+include $(G4INSTALL)/config/architecture.gmk
+
+ifdef G4ANALYSIS_USE
+CPPFLAGS += -DANALYSIS_USE
+endif
+ifndef G4ANALYSIS_USE      # If we don't have AIDA
+ifdef G4ANALYSIS_USE_ROOT   # And we have ROOT
+CPPFLAGS += -DANALYSIS_USE -DG4ANALYSIS_USE_ROOT
+CPPFLAGS += $(shell root-config --cflags)
+LDFLAGS  += $(shell root-config --glibs)
+endif
+endif
+
 include $(G4INSTALL)/config/binmake.gmk
 
-ifdef G4ANALYSIS_USE  
- CPPFLAGS += `aida-config --include`
- LDFLAGS  += `aida-config --lib`
- LOADLIBS += `aida-config --lib` 
+ifdef G4ANALYSIS_USE 
 endif
Index: trunk/examples/advanced/hadrontherapy/Hadrontherapy.cc
===================================================================
--- trunk/examples/advanced/hadrontherapy/Hadrontherapy.cc	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/Hadrontherapy.cc	(revision 1230)
@@ -24,5 +24,13 @@
 // ********************************************************************
 //
-// $Id: Hadrontherapy.cc Main of the Hadrontherapy example; Version 4.0 May 2005
+// Hadrontherapy.cc 
+//
+// Main of the Hadrontherapy example; 
+// Released with the Geant4 9.3 version (December 2009)
+//
+// Last modified: G.A.P.Cirrone
+// 
+// See more at: http://g4advancedexamples.lngs.infn.it/Examples/hadrontherapy
+//
 // ----------------------------------------------------------------------------
 //                 GEANT 4 - Hadrontherapy example
@@ -30,26 +38,33 @@
 // Code developed by:
 //
-// G.A.P. Cirrone(a)*, F. Di Rosa(a), S. Guatelli(b), G. Russo(a)
+// G.A.P. Cirrone(a)Â°, G.Cuttone(a), F.Di Rosa(a), E.Mazzaglia(a), F.Romano(a)
 // 
+// Contributor authors:
+// P.Kaitaniemi(d), A.Heikkinen(d), Gillis Danielsen (d)
+//
+// Past authors:
+// M.G.Pia(b), S.Guatelli(c), G.Russo(a), M.Russo(a), A.Lechner(e) 
+//
 // (a) Laboratori Nazionali del Sud 
 //     of the INFN, Catania, Italy
-// (b) INFN Section of Genova, Genova, Italy
+//
+// (b) INFN Section of Genova, Italy
 // 
-// * cirrone@lns.infn.it
+// (c) University of Wallongong, Australia
+//
+// (d) Helsinki Institute of Physics, Helsinki, Finland
+//
+// (e) CERN, (CH)
+//
+//  *Corresponding author, email to cirrone@lns.infn.it
 // ----------------------------------------------------------------------------
+
 #include "G4RunManager.hh"
 #include "G4UImanager.hh"
 #include "G4UIterminal.hh"
 #include "G4UItcsh.hh"
-#ifdef G4UI_USE_XM
-#include "G4UIXm.hh"
-#endif
-#ifdef G4VIS_USE
-#include "G4VisExecutive.hh"
-#endif
 #include "HadrontherapyEventAction.hh"
-#include "HadrontherapyDetectorConstruction.hh"
 #include "HadrontherapyPhysicsList.hh"
-#include "HadrontherapyPhantomSD.hh"
+#include "HadrontherapyDetectorSD.hh"
 #include "HadrontherapyPrimaryGeneratorAction.hh"
 #include "HadrontherapyRunAction.hh"
@@ -61,90 +76,137 @@
 #include "globals.hh"
 #include "HadrontherapySteppingAction.hh"
-#ifdef  G4ANALYSIS_USE
 #include "HadrontherapyAnalysisManager.hh"
-#endif
-
+#include "HadrontherapyGeometryController.hh"
+#include "HadrontherapyGeometryMessenger.hh"
+#include "HadrontherapyInteractionParameters.hh"
+#include "G4ScoringManager.hh"
+#include "IAEAScoreWriter.hh"
+
+#if defined(G4UI_USE_TCSH)
+#include "G4UIterminal.hh"
+#include "G4UItcsh.hh"
+#endif
+
+#ifdef G4UI_USE_XM
+#include "G4UIXm.hh"
+#endif
+
+#ifdef G4VIS_USE
+#include "G4VisExecutive.hh"
+#endif
+
+#ifdef G4UI_USE_QT
+#include "G4UIQt.hh"
+#include "G4Qt.hh"
+#endif
+
+//////////////////////////////////////////////////////////////////////////////////////////////
 int main(int argc ,char ** argv)
 {
-
   // Set the Random engine
-
   CLHEP::HepRandom::setTheEngine(new CLHEP::RanecuEngine());
 
   G4RunManager* runManager = new G4RunManager;
 
-  // Initialize the geometry
-  runManager -> SetUserInitialization(new HadrontherapyDetectorConstruction());
-  
+  //Initialize possible analysis needs, needs to come early in order to pick up metadata
+#ifdef ANALYSIS_USE
+  HadrontherapyAnalysisManager* analysis = HadrontherapyAnalysisManager::getInstance();
+  analysis -> book();
+#endif
+  // Geometry controller is responsible for instantiating the
+  // geometries. All geometry specific setup tasks are now in class
+  // HadrontherapyGeometryController.
+  HadrontherapyGeometryController *geometryController = new HadrontherapyGeometryController();
+
+  // Connect the geometry controller to the G4 user interface
+  HadrontherapyGeometryMessenger *geometryMessenger = new HadrontherapyGeometryMessenger(geometryController);
+
+  G4ScoringManager *scoringManager = G4ScoringManager::GetScoringManager();
+  scoringManager->SetVerboseLevel(1);
+  scoringManager->SetScoreWriter(new IAEAScoreWriter());
+
+  // Initialize the default Hadrontherapy geometry
+  geometryController->SetGeometry("default");
+
+  // Initialize command based scoring
+  G4ScoringManager::GetScoringManager();
+
   // Initialize the physics 
   runManager -> SetUserInitialization(new HadrontherapyPhysicsList());
+
+  // Initialize the primary particles
+  HadrontherapyPrimaryGeneratorAction *pPrimaryGenerator = new HadrontherapyPrimaryGeneratorAction();
+  runManager -> SetUserAction(pPrimaryGenerator);
   
-  // Initialize the primary particles  
-  runManager -> SetUserAction(new HadrontherapyPrimaryGeneratorAction());
-
-  // Initialize matrix 
-  HadrontherapyMatrix* matrix = new HadrontherapyMatrix();
-  matrix -> Initialize();
-
   // Optional UserActions: run, event, stepping
   HadrontherapyRunAction* pRunAction = new HadrontherapyRunAction();
   runManager -> SetUserAction(pRunAction);
 
-  HadrontherapyEventAction* pEventAction = new HadrontherapyEventAction(matrix);
+  HadrontherapyEventAction* pEventAction = new HadrontherapyEventAction();
   runManager -> SetUserAction(pEventAction);
-
 
   HadrontherapySteppingAction* steppingAction = new HadrontherapySteppingAction(pRunAction); 
   runManager -> SetUserAction(steppingAction);    
 
-
-#ifdef G4ANALYSIS_USE
-  HadrontherapyAnalysisManager* analysis = 
-    HadrontherapyAnalysisManager::getInstance();
-  analysis -> book();
-#endif
-  
+  // Interaction data: stopping powers
+  HadrontherapyInteractionParameters* pInteraction = new HadrontherapyInteractionParameters();
+
 #ifdef G4VIS_USE
   // Visualization manager
   G4VisManager* visManager = new G4VisExecutive;
   visManager -> Initialize();
-#endif
+#endif 
+
+G4UImanager* UI = G4UImanager::GetUIpointer();      
   
+ if (argc!=1)   // batch mode
+   {
+     G4String command = "/control/execute ";
+     G4String fileName = argv[1];
+     UI->ApplyCommand(command+fileName);    
+   }
+ 
+ else  // interactive mode : define visualization UI terminal
+   {
+     G4UIsession* session = 0;
+     
+     // If the enviroment variable for the TCSH terminal is active, it is used and the
+     // defaultMacro.mac file is executed
+#if defined(G4UI_USE_TCSH)
+     session = new G4UIterminal(new G4UItcsh);      
+     UI->ApplyCommand("/control/execute defaultMacro.mac");  
+
+     // Alternatively (if G4UI_USE_TCSH is not defined)  the program search for the
+     // G$UI_USE_QT variable. It starts a graphical user interface based on the QT libraries
+     // In the following case the GUI.mac file is also executed
+     // 
+#elif defined(G4UI_USE_QT)
+     session = new G4UIQt(argc,argv);
+     UI->ApplyCommand("/control/execute macro/GUI.mac");      
+     
+     // As final option, the simpler user interface terminal is opened
+#else
+    session = new G4UIterminal();
+    UI->ApplyCommand("/control/execute defaultMacro.mac");
+#endif
+    session->SessionStart();
+    delete session;
+   }
+    HadrontherapyMatrix* matrix = HadrontherapyMatrix::getInstance();
+    if (matrix) matrix -> TotalEnergyDeposit();
+ 
+#ifdef ANALYSIS_USE
+ analysis -> finish();
+#endif
+
+ // Job termination
+#ifdef G4VIS_USE
+ delete visManager;
+#endif
   
-  G4UIsession* session = 0;
-  if (argc == 1)   // Define UI session for interactive mode.
-    {
-      session = new G4UIterminal();
-    } 
-
-  // Get the pointer to the User Interface manager 
-  G4UImanager* UI = G4UImanager::GetUIpointer();  
-  if (session)   // Define UI session for interactive mode.
-    { 
-      G4cout<<" UI session starts ..."<< G4endl;
-      UI -> ApplyCommand("/control/execute defaultMacro.mac");    
-      session -> SessionStart();
-      delete session;
-    }
-  else           // Batch mode
-    { 
-      G4String command = "/control/execute ";
-      G4String fileName = argv[1];
-      UI -> ApplyCommand(command + fileName);
-    }  
-
-  matrix -> TotalEnergyDeposit();
-
-#ifdef G4ANALYSIS_USE
-  analysis -> finish();
-#endif
-  
-  // Job termination
-#ifdef G4VIS_USE
-  delete visManager;
-#endif
-
+  delete geometryMessenger;
+  delete geometryController;
+  delete pInteraction; 
   delete runManager;
-
   return 0;
 }
Index: trunk/examples/advanced/hadrontherapy/History
===================================================================
--- trunk/examples/advanced/hadrontherapy/History	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/History	(revision 1230)
@@ -1,11 +1,272 @@
------------------------------------------------------------
-$Id: History, v 1.6 2004/02/27  G.A.P. Cirrone
------------------------------------------------------------
-
-     ====================================================
-                     Geant4 - Hadrontherapy
-     ====================================================
-
-                      Category History file
+ -------------------------------------------------------------------------------
+History File, 2004/02/27 G.A.P. Cirrone, Created
+cirrone@lns.infn.it
+http://g4advancedexamples.lngs.infn.it/Examples/hadrontherapy
+-------------------------------------------------------------------------------
+
+         ====================================================
+             History file of the Hadrontherapy application
+         ====================================================
+
+25.11.2009 S.E.Mazzaglia & F.Romano; Tag:Hadrontherapy-V09-02-40
+           - Corrected a bug in HadrontherapyDetectorConstruction class 
+	   - Added G4RadiactiveDecayPhysics class to the Physics List. 
+
+22.11.2009 S.E.Mazzaglia; Tag: Hadrontherapy-V09-02-39
+           - Correction in the initialization of the passiveProtonBeamLine class.
+
+20.11.2009 P.Kaitaniemi; Tag: hadrontherapy-V09-02-38
+           - Fixes and updates to the analysis scripts in RootScripts/iaeaBenchmark
+           - Updated RootScripts/README
+
+19.11.2009 G.A.P.Cirrone; Tag: hadrontherapy-V09-02-37
+           - Minor revisions;
+
+18.11.2009 G.A.P.Cirrone; Tag: hadrontherapy-V09-02-36
+           - Correction for a missing function in the HadrontherapyPhysicsListMessenger.cc class file
+
+18.11.2009 G.A.P.Cirrone; Tag: hadrontherapy-V09-02-35
+           - Updated the README file and general code revision for the 
+             Geant4 9.3 release
+
+17.11.2009 S.E.Mazzaglia; Tag: hadrontherapy-V09-02-34
+	   - Added some functionalities in order to change, via messengers, the geometry, the voxelization 
+	     of the detector, and the disposition in the space of the detector/phantom.
+	   - Added the possibility to calculate the stopping powers for ions too.
+	   - Modified the HadrontherapyDetectorROGeometry class constructor.
+	   - Various additions and fixes to the matrix class.
+
+10.11.2009 G.A.P.Cirrone; Tag: hadrontherapy-V09-02-33
+           - Added the possibility to make a graphical user interface (GUI) using the QT libraries. 
+             To start a GUI the correct enviroment variables must be configured (see the Geant4 installation 
+             manual) and a QT version must be installed  
+
+05.10.2009 P.Kaitaniemi; Tag: hadrontherapy-V09-02-32
+           - Fixed a compilation error with GCC 4.4
+
+28.09.2009 S.E.Mazzaglia; Tag: hadrontherapy-V09-02-31
+           - Now the HadrontherapyDetectorConstruction class implements only phantom and detector [RO]geometry.
+	     World volume and the rest of the geometry is inside another class whose messenger allows 
+	     modification by users with the same old syntax
+	   - Removed HadrontherapyInteractionParameters from the HadrontherapyGeometryController class 
+			  
+20.09.2009 P.Kaitaniemi; Tag: hadrontherapy-V09-02-30
+           - Added ability to use command based scoring
+           - IAEA geometry: produce Bragg peak using command based scoring
+           - Various additions and fixes to the IAEA ROOT scripts
+           - Additional data extracted from E. Haettner's thesis
+
+20.09.2009 P.Kaitaniemi; Tag: hadrontherapy-V09-02-29
+           - Moved HadrontherapyInteractionParameters initialization to the HadrontherapyGeometryController class
+
+11.09.2009 G.A.P.Cirrone; Tag: hadrontherapy-V09-02-28
+           - Added messengers to control the event number and to draw only particular tracks.
+             The new command are accessible via the command /event/drawTracks and /event/PrintEventNumber  
+
+08.09.2009 S.E.Mazzaglia; Tag: hadrontherapy-V09-02-27
+           - Added a method to retrieve stopping power values for protons, alphas and electrons.
+	     This method is implemented in the new class HadrontherapyInteractionParameters
+
+13.08.2009 P.Kaitaniemi; Tag: hadrontherapy-V09-02-26
+           - Fixed compilation errors when AIDA analysis is used
+
+03.08.2009 P.Kaitaniemi; Tag: hadrontherapy-V09-02-25
+           - Added ability to select the geometry using G4 macro commands
+           - Improved plotting scripts and improved normalization for the
+             fragment energy distribution
+
+27.07.2009 P.Kaitaniemi; Tag: hadrontherapy-V09-02-24
+           - IAEA geometry: added ability to remove the phantom by setting its thickness to zero
+           - Collect simulation metadata: number of events, distance of the detector (IAEA geometry),
+             depth of the phantom (IAEA geometry), beam energy, energy error
+           - Added ability to produce angular distribution plots
+
+17.07.2009 P.Kaitaniemi; Tag: hadrontherapy-V09-02-23
+           - Tuned geometry of the E. Haettner experimet (IAEADetectorConstruction)
+           - Adopted G4ANALYSIS_USE_ROOT flag to activate ROOT analysis
+           - Improved plotting scripts
+
+13.07.2009 P.Kaitaniemi; Tag: hadrontherapy-V09-02-22
+           - Added the first version of the IAEA benchmark geometry based on
+              E. Haettner's thesis
+           - Collect fragment energy distributions
+           - Added fragment energy distribution data
+           - ROOT script preparing an IAEA benchmark figure with data
+
+08.07.2009 G.A.P.Cirrone; Tag: hadrontherapy-V09-02-21
+           - Removed the README file in ASCII format 
+
+27.06.2009 G.A.P.Cirrone; Tag: hadrontherapy-V09-02-20
+           - Eliminated not necessary dependences in the SteppingAction class
+           - Added folders containing experimental data (its name is 'experimentalData') and 
+             ROOT scripts ('RootScripts') where Root scripts are stored to
+             perform a fast comparison with experimental data.
+             A folder where simulation results are stored is also created. Its
+             name is 'simulationResults'. 
+
+27.06.2009 P. Kaitaniemi; Tag hadrontherapy-V09-02-19
+	   - Added ability to change the name of the output file between runs
+
+26.06.2009 P. Kaitaniemi; Tag hadrontherapy-V09-02-18
+	   - Fixed a bug in the physics list. Local ion-ion hadronic physics was not loaded due
+	     to an uninitialized variable (locIonIonInelasticIsRegistered)
+	   - Ability to use /analysis/setAnalysisFile <filename> to set the name of the output file
+	   - Added Doxygen documentation tags to the source code and Doxyfile for
+	     documentation settings
+	   - Support for direct use of ROOT for analysis in addition to the default AIDA one
+	   - Local INCL/ABLA physics list for deuterons, tritons and alphas
+
+26.06.2009 G.A.P.Cirrone; Tag hadrontherapy-V09-02-17
+           - Corrected the definition of total inelastic cross section for light ions in the 
+             LocalIonIonInelasticPhysic.cc file
+
+26.06.2009 G.A.P.Cirrone; Tag: hadrontherapy-V09-02-16
+           - Momentarely removed the class for LET calculation 
+             for a conflict with the general structure of Hadrontherapy
+
+10.06.2009 G.A.P.Cirrone; Tag: hadrontherapy-V09-02-15
+           - Corrected a bug in the detector construction
+
+05.06.2009 G.A.P.Cirrone and S.Mazzaglia; Tag: hadrontherapy-V09-02-14
+           - Added a preliminary version of classes for LET calculation.
+
+30.05.2009 G.A.P.Cirrone; Tag hadrontherapy-V09-02-13
+           - README_Hadrontherapy.pdf file updated and improved
+
+29.05.2009 G.A.P.Cirrone; Tag hadrontherapy-V09-02-12
+           - Implemented the new Low energy models (Livermore and Penelope)
+             now migrated to the new interface (common to the Standard models)
+	     Livermore and Penelope models can be implemented:
+             Activating the buit-in physics lists (G4EmLivermorePhysics and G4EmPenelopePhysics)
+             Activation can be done via macro commands in the usual way
+
+19.05.2009 F.Romano; Tag hadrontherapy-V09-02-11
+           - Corrected the stepMax value in each macro in order to avoid 
+	     a wrong dose deposition in the first slice.
+	   - Modified and revised the README and macro files.
+
+15.05.2009 G.A.P.Cirrone; Tag hadrontherapy-V09-02-10
+           - Corrected a but in the call of a physic list
+           - Corrected a bug in the proton_therapy.mac file
+
+14.05.2009 G.A.P.Cirrone; Tag hadrontherapy-V09-02-09
+           - Definitively added the StepMax class to change the max step lenght
+
+14.05.2009  G.A.P.Cirrone; Tag: hadrontherapy-V09-02-08
+           - README file improved.
+
+14.05.2009  G.A.P.Cirrone; Tag: hadrontherapy-V09-02-07
+	   - Physic implementation completely changed. Now Hadrontherapy can be launched 
+             with physics lists, packages and built-in physic models;
+             In the README we give some suggestion in the physic models to use.
+             All models can be activated via macro command.
+           - Improved HadrontherapyModulator.cc file;
+
+29.03.2009  G.A.P.Cirrone; Tag: hadrontehrapy-V09-02-06
+	   - Extended limits of Binary Cascade in HIProtonNeutronBinary.cc
+	   - Corrected and improved "default" macro file.
+	   - Improved HadrontherapyDetectorConstruction.cc file;
+           - Comments on HIProtonneutronPrecompound.cc file;
+           - Improved physicsHadronicPrecompound.mac file;
+
+18.03.2009  G.A.P.Cirrone; Tag: hadrontherapy-V09-02-05
+           - Corrected macro file for the use of the QGSP_BIC package
+
+18.03.2009: G.A.P.Cirrone; Tag: hadrontherapy-V09-02-04
+	   - Added commands to Detector Messenger to give the possibility to choose beetween
+	     different beam lines
+	   - Added comments to HadrontherapyMatrix;
+	   _ Improved code and added comments to HIProtonNeutronPrecompound and
+	     HIProtonNeutronBinary;
+	   - Corrected macro file using the Precompound inelastic model;
+	   - Removed the class file HadrontherapyMaterial and improved all the geometry files
+
+05.03.2009: G.A.P.Cirrone; Tag: hadrontherapy-V09-02-03
+	   - Updated README
+
+02.03.2009: G.A.P.Cirrone; Tag: hadrontherapy-V09-02-02
+           - Changed name of HadrontherapyBeamLine file to PassiveProtonBeamLine
+
+02.03.2009: G.A.P.Cirrone; Tag:  hadrontherapy-V09-02-01
+	   - Added generation of ASCII file with dose deposited in the phantom voxels
+
+22.02.2009: G.Folger; Tag: hadrontherapy-V09-02-00
+           - Fix a compilation warning on used ionShenCrossSection in
+	     HIIonLEP.cc
+
+20.11.2008: G.A.P.Cirrone and M.Russo; Tag: hadrontherapy-V09-01-11
+	   - Fixed path of macro files
+
+20.11.2008: G.A.P.Cirrone; Tag: hadrontherapy-V09-01-10
+           - Updated the History file
+           - Corrected cross sections definitions for ions
+           - Revised the definition and use of the electromagnetic options
+             for the use with the Standard models
+             
+20.11.2008: G.A.P.Cirrone and M.Russo; Tag: hadrontherapy-V09-01-09
+           - Updated readme and improved the comments. 
+
+20.11.2008: G.A.P.Cirrone and M.Russo; Tag: hadrontherapy-V09-01-08
+	   - Add new approach for the choice of the physic models.
+             Now packaged physic lists can be used alternatively 
+             to the the physic models implemented in the class files
+             EM, HE and HI. 
+           - Improved the electromagnetic models for the generic ions
+
+22.09.2008 G.A.P.Cirrone; Tag: hadrontherapy-V09-01-07
+           - Corrected the G4eBremsstrahlung() process in the file 
+             EMElectronStandard.cc;
+           - Updated the head of the History file;
+
+17.09.2008 A.Lechner; Tag: hadrontherapy-V09-01-06
+           - Corrections in the Low Energy Electromagnetic physic lists.
+
+15.06.2008 G.A.P.Cirrone; Tag: hadrontherapy-V09-01-05
+	   - Removed AIDA call from GNUmakefile 
+
+19.05.2008 G.A.P.Cirrone tag hadrontherapy-V09-01-04
+           - Added in the beam line the MOPI detector. MOPI is a microstrip
+             detector that, in the real case, is able to check during
+             the treatment, the beam simmetry of the therapy beam.
+             Its physical structure is here exactly simulated so that 
+             the its contribute to the energy loss can be take into account;
+             A detailed description if the detector can be found in 
+             NIM A 572 (2007) 1094-1101 and its references.
+	   - Corrected the position of the Phantom and Detector;
+           - Added variables to the HadrontherapyBeamLine.cc file;
+           - Added comments to the HadrontherapyBeamLine.cc file
+             to improve the clearness.
+           - Updated the README file.
+           - Changed the default dimensions of histogram bins 
+             (from 200 um to 100 um).
+
+09.03.2008 G.A.P.Cirrone tag hadrontherapy-V09-01-03
+	   - Completed the update of the new beam line
+
+09.03.2008 G.A.P.Cirrone tag hadrontherapy-V09-01-02
+	   - Added comments to the PhysicsList class;
+	   - Eliminated not used production cuts in PhysicsList;
+	   - Added NIST definition materials in Material class;
+	   - Code review of the DetectorConstruction class;
+           - Changed name of the volume where the energy deposited is collected
+             from "phantom" to "detector". "Detector" is a more appropiate 
+             name.
+	   - Changed name of the volume where the detector is inserted from 
+	     "patient" to the more appropriate "Water Phantom";
+
+03.03.2008 G.A.P.Cirrone tag hadrontherapy-V09-01-01
+           - Added the generation of .root file;
+	   - Removed a segmentation due to an uncorect pointer
+	     in the EMHadronIonStandard class;
+	   - Added options for an accurate use of Standard electromagnetic models
+	     in the EMHadronIonStandard, EMElectronStandard, 
+	     EMPositronStandard, EMPhotonStandard  and EMMuonStandard classes;
+	   - Added a macro file (physicsElectromagneticStandard.mac) 
+ 	     for the use of Hadrontherapy with the Standard Electromagnetic models;
+	   - Corrected in the defaultMacro.mac, a wrong command for the 
+ 	     activation of the Standard Electromagnetic models;
+         
+29.02.2007 G.A.P.Cirrone tag hadrontherapy-V09-01-00
+	   - Updated README
 
 16.11.2007 Anton Lechner tag hadrontherapy-V09-00-00
@@ -31,6 +292,6 @@
 
 07.05.2007 G.A.P. Cirrone (hadrontherapy-V08-02-02)
-	 - Geometry upgrade(hadrontherapyBeamLine class) according to the experimental CATANA 
-	    proton therapy beam line; 
+	 - Geometry upgrade(hadrontherapyBeamLine class) according 
+           to the experimental CATANA proton therapy beam line; 
 
 23.04.2007 S. Guatelli (hadrontherapy-V08-02-01)
Index: trunk/examples/advanced/hadrontherapy/defaultMacro.mac
===================================================================
--- trunk/examples/advanced/hadrontherapy/defaultMacro.mac	(revision 812)
+++ trunk/examples/advanced/hadrontherapy/defaultMacro.mac	(revision 1230)
@@ -1,67 +1,71 @@
-#----------------------------------------------------------------------------
-# DEFAULT MACRO FOR THE  
-# HADRONTHERAPY EXAMPLE
+# G.A.P.Cirrone
 #
+# Default macro file. It is called if no argument is provided at run
+# 
+# i.e. simply typing $G4WORKDIR/bin/Linux-++/Hadrontherapy <no argument here!> 
 #
-# THIS MACRO SIMPLY PERMIT TO  RUN A SIMULATION 
-# WITHOUT THE VISUALISATION  
+# This macro can be used for a proton beam in water. Both electrmagnetic and
+# hadronic models are swiched on
+
+#########################
+# Set of the verboses 
 #
-# THE RANGE SHIFTER MATERIAL AND THICKNESS CAN BE SPECIFIED 
-#
-# NOTE THAT THE MODULATOR MATERIAL IS POLTMETHYLMETHACRILATE 
-# (PMMA) FOR DEFAULT. IF ONE WANT CARRY OUT A SIMULATION WITHOUT 
-# THE MODULATOR HE/SHE MUST SET "Air" the <<ModMater>> in the
-# <<GetMater>> function of the HadrontherapyModulator.cc class
-#
-# USERS SHOULD GIVE A LOOK TO THE HELP OF THE IDLE TO KNOW
-# THE ACTIVATED MESSSENGERS FOR THE GEOMETRY
-#
-# ADDITIONAL INFORMATIONS ON THE MESSENGER AVAILABLE CAN BE FOUND
-# INSIDE THE HADRONTHERAPY DOCUMENTATION (http://www.ge.infn.it/geant4/examples/).
-# 
-# ANYWAY SEND ME AN E-MAIL FOR ANY QUESTION: cirrone@lns.infn.it.   
-# --------------------------------------------------------------------------------  
-
-
 /control/verbose 1
 /tracking/verbose 0
-/run/verbose 0
+/run/verbose 1
 /event/verbose 0
 
-# SETTING FOR THE PHYSICS MODELS
-/physics/addPhysics Decay
-/physics/addPhysics EM-Photon-EPDL
-/physics/addPhysics EM-Electron-EEDL
-/physics/addPhysics EM-Positron-Standard
-/physics/addPhysics EM-HadronIon-LowE
-/physics/addPhysics EM-Muon-Standard
-/physics/addPhysics HadronicEl-HadronIon-LElastic
-/physics/addPhysics HadronicInel-ProtonNeutron-LEP
-/physics/addPhysics HadronicInel-Ion-LEP
-/physics/addPhysics HadronicInel-Pion-LEP
-/physics/addPhysics HadronicAtRest-MuonMinus-Capture
+##########################
+# Set of the physic models
+#
+/physic/addPhysics emstandard_opt3                     # Electromagnetic model
+/physic/addPhysics elastic                             # Hadronic elastic model
+/physic/addPhysics binary                              # Hadronic inelastic model
+/physic/addPhysics local_ion_ion_inelastic             # Hadronic inelastic model for ions (local physic list)
 
-# FIX THE FOLLOWIG PARAMETERS
-# TO SET THE RANGE SHIFTER
-#/beamLine/RangeShifter/thickness 4 cm
-#/beamLine/RangeShifter/RSMat Water
-#/tracking/verbose 1
-# SET OF THE VISUALISATION CHARACTERISTICS
+##########################
+# Initialisation procedure
+#
+/run/initialize
+
+##########################
+# Visualisation 
+#
 /vis/scene/create
+#/vis/open OGLIQt # only if QT library are installed
 /vis/open OGLIX
 /vis/viewer/flush
+/vis/viewer/set/viewpointThetaPhi 30 140 deg
+/vis/viewer/zoom 1
+/vis/viewer/pan -10  0 cm
 /tracking/storeTrajectory 1
-/vis/scene/endOfEventAction accumulate
+#/vis/scene/endOfEventAction accumulate
+/vis/scene/endOfEventAction accumulate -1
 /vis/viewer/update
-/run/beamOn 100
 
+##########################
+# Set here the cut and the step max for the tracking. 
+# Suggested values of cut and step:
+#
+/physic/setCuts 0.01 mm
+/Step/waterPhantomStepMax 0.01 mm 
 
+#########################
+# Set the primary particle type,
+# energy and position along the X direction
+#
+/gun/particle proton
+/beam/energy/meanEnergy 62 MeV
+/beam/energy/sigmaEnergy 400 keV
+/beam/position/Xposition -2700 mm
 
+#########################
+# Display the event number
+# during the run
+# 
+/event/printEventNumber 10
 
-
-
-
-
-
-
-
+#########################
+# Start of the run
+#
+/run/beamOn 10
Index: trunk/examples/advanced/hadrontherapy/include/CVS/Entries
===================================================================
--- trunk/examples/advanced/hadrontherapy/include/CVS/Entries	(revision 1230)
+++ trunk/examples/advanced/hadrontherapy/include/CVS/Entries	(revision 1230)
@@ -0,0 +1,34 @@
+/Decay.hh/1.2/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyAnalysisFileMessenger.hh/1.4/Fri Jan  8 13:32:05 2010//Tgeant4-09-03
+/HadrontherapyAnalysisManager.hh/1.16/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyDetectorConstruction.hh/1.24/Fri Jan  8 13:32:05 2010//Tgeant4-09-03
+/HadrontherapyDetectorHit.hh/1.2/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyDetectorMessenger.hh/1.15/Fri Jan  8 13:32:05 2010//Tgeant4-09-03
+/HadrontherapyDetectorROGeometry.hh/1.3/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyDetectorSD.hh/1.2/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyDummySD.hh/1.6/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyEventAction.hh/1.15/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyEventActionMessenger.hh/1.2/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyGeometryController.hh/1.2/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyGeometryMessenger.hh/1.2/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyInteractionParameters.hh/1.5/Fri Jan  8 13:32:05 2010//Tgeant4-09-03
+/HadrontherapyMatrix.hh/1.6/Fri Jan  8 13:32:05 2010//Tgeant4-09-03
+/HadrontherapyModulator.hh/1.5/Thu Jun 29 15:58:08 2006//Tgeant4-09-03
+/HadrontherapyParameterMessenger.hh/1.5/Fri Jan  8 13:32:05 2010//Tgeant4-09-03
+/HadrontherapyParticles.hh/1.7/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyPhysicsList.hh/1.21/Fri Jan  8 13:32:05 2010//Tgeant4-09-03
+/HadrontherapyPhysicsListMessenger.hh/1.9/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyPrimaryGeneratorAction.hh/1.17/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyPrimaryGeneratorMessenger.hh/1.7/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyRunAction.hh/1.14/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyStepMax.hh/1.2/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapyStepMaxMessenger.hh/1.3/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/HadrontherapySteppingAction.hh/1.16/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/IAEADetectorConstruction.hh/1.5/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/IAEADetectorMessenger.hh/1.2/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/IAEAScoreWriter.hh/1.3/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/LocalINCLIonIonInelasticPhysic.hh/1.2/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/LocalIonIonInelasticPhysic.hh/1.2/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/PassiveProtonBeamLine.hh/1.5/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+/PassiveProtonBeamLineMessenger.hh/1.2/Wed Nov 18 14:37:51 2009//Tgeant4-09-03
+D
Index: trunk/examples/advanced/hadrontherapy/include/CVS/Repository
===================================================================
--- trunk/examples/advanced/hadrontherapy/include/CVS/Repository	(revision 1230)
+++ trunk/examples/advanced/hadrontherapy/include/CVS/Repository	(revision 1230)
@@ -0,0 +1,1 @@
+geant4/examples/advanced/hadrontherapy/include
Index: trunk/examples/advanced/hadrontherapy/include/CVS/Root
===================================================================
--- trunk/examples/advanced/hadrontherapy/include/CVS/Root	(revision 1230)
+++ trunk/examples/advanced/hadrontherapy/include/CVS/Root	(revision 1230)
@@ -0,0 +1,1 @@
+:ext:lgarnier@geant4.cvs.cern.ch:/cvs/Geant4
